//Copyright (c) 2023-2023 NOIP Program Master Co, Ltd.All Right Reserved.
//Add version : v1.0.0-alpha|0x00
//Latest Update : v1.0.0-alpha|0x00
#include <bits/stdc++.h>
using namespace std;


#ifndef EXPR_H
#define EXPR_H
struct expr_obj {
    int mode=-1;
    int value; //mode == 0
    char op;   //mode == 1
    expr_obj() {value=-(0xfc);op='\0';}
    expr_obj(int _value) {mode=0;value=_value;}
    expr_obj(char _op) {mode=1;op=_op;}
};

int priority(char op) {
    if (op=='+'||op=='-') return 0;
    if (op=='*'||op=='/') return 1;
    if (op=='^') return 2;
    return -(0xfc);
}

int qp(int a, int b) {
	if (b==0) return 1;
	if (b==1) return a;
	int k=qp(a, b/2);
	return k*k*(b&1?a:1);
}

string expr_calc(vector<expr_obj> p) {
    stack<expr_obj> obstack;
    if (p[0].mode==2) return "Invaild expression.";
    for (int i=0;i<p.size();i++) {
    	if (obstack.empty()) obstack.push(p[i]);
    	else if (p[i].mode==0) obstack.push(p[i]);
    	else if (p[i].mode==1) {
    		if (obstack.size()<2) return "Invaild expression.";
    		expr_obj x1,x2;
    		x2 = obstack.top();obstack.pop();
    		x1 = obstack.top();obstack.pop();
    		if (p[i].op=='+') obstack.push(expr_obj{x1.value+x2.value});
    		if (p[i].op=='-') obstack.push(expr_obj{x1.value-x2.value});
    		if (p[i].op=='*') obstack.push(expr_obj{x1.value*x2.value});
    		if (p[i].op=='/') obstack.push(expr_obj{x1.value/x2.value});
    		if (p[i].op=='^') obstack.push(expr_obj{qp(x1.value, x2.value)});
    	}
    }
    char _='\0';
    return itoa(obstack.top().value, &_, 10);
}

vector<expr_obj> parser(string k) {
    //Original code by OI-wiki http://oi-wiki.com/misc/expression/
    string tmp=""; int ptr=0;
    vector<expr_obj> post_expr, inv;
    expr_obj tp;tp.mode=2;
    inv.push_back(tp);
    stack<char> opstack;
    while(ptr<k.length()) {
    	if ('0'<=k[ptr]&&k[ptr]<='9') { // cond. 04
            tmp += k[ptr];
            ptr++;
            continue;
        }
        else if (tmp!="") {
            post_expr.push_back(expr_obj{atoi(tmp.c_str())});
            tmp = "";
        }
        if (k[ptr] == '(') { // cond. 01
            opstack.push('(');
        }
        else if (k[ptr] == ')') { // cond. 02
        	if (opstack.empty()) return inv;
            while (opstack.top() != '(') {
                post_expr.push_back(expr_obj{opstack.top()});
                opstack.pop();
            }
            opstack.pop();
        }
        else { // cond. 03
            int c_p = priority(k[ptr]);
            if (c_p==-(0xfc)) return inv;
            
            while (!opstack.empty()&&priority(opstack.top())>=c_p) {
                post_expr.push_back(expr_obj{opstack.top()});
                opstack.pop();
            }
            opstack.push(k[ptr]);
        }
        ptr++;
    }
    if (tmp!="") {
        post_expr.push_back(expr_obj{atoi(tmp.c_str())});
        tmp = "";
    }
    while (!opstack.empty()) {
    	if (opstack.top() == '(') return inv;
    	post_expr.push_back(expr_obj{opstack.top()});
    	opstack.pop();
    }
    return post_expr;
}

string expr_solve(string k) {return expr_calc(parser(k));}
#endif

