//Copyright (c) 2023-2023 NOIP Program Master Co, Ltd.All Right Reserved.
//Add version : v1.0.0-alpha|0x00
//Latest Update : v1.0.0-alpha|0x00
#include <bits/stdc++.h>
using namespace std;


#ifndef LABYRINTH_H
#define LABYRINTH_H
#define vec vector<vector<long long> >
int h, w;
struct pos {
    int y, x;
};

bool operator< (const pos &a, const pos &b) {
    if (a.y != b.y) return a.y < b.y;
    return a.x < b.x;
}

bool det(vec grid, int cy, int cx, int ey, int ex) {
    if (cy<0||cy>=h||cx<0||cx>=w) return false;
    if (grid[cy][cx]==1) return false;
    if (cy==ey&&cx==ex) return true;
    grid[cy][cx] = 1;
    bool res=false;
    res |= det(grid, cy-1, cx, ey, ex);
    res |= det(grid, cy+1, cx, ey, ex);
    res |= det(grid, cy, cx-1, ey, ex);
    res |= det(grid, cy, cx+1, ey, ex);
    return res;
}

vec extend(vec grid, int cy, int cx) {
    if (cy<0||cy>=h||cx<0||cx>=w) return grid;
    if (grid[cy][cx]==1) return grid;
    grid[cy][cx] = 1;
  
    grid = extend(grid, cy-1, cx);
    grid = extend(grid, cy+1, cx);
    grid = extend(grid, cy, cx-1);
    grid = extend(grid, cy, cx+1);
    return grid;
}

int extendv(vec grid, int cy, int cx, int ey, int ex) {
  
    deque<pos> pq;
    set<pos> accessed;
    int dep = 1;
    pq.push_back(pos{cy, cx});
  
    grid[cy][cx] = dep;
    while(!pq.empty()) {
        int d[4][2] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
        for (int i=0;i<4;i++) {
        	int ky = pq.front().y + d[i][0], kx = pq.front().x + d[i][1];
        	if (ky>=0&&ky<h&&kx>=0&&kx<w&&grid[ky][kx]==0) pq.push_back(pos{ky, kx});
  
        }
        accessed.insert(pq.front());
        pq.pop_front();
        dep++;
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].y][pq[i].x] = dep;
		}
    }
    int count=0;
    for (int i=0;i<h;i++) {
    	for (int j=0;j<w;j++) {
    		if (grid[i][j]!=-1) count++;
		}
	}
	return count;
};

int step(vec grid, int cy, int cx, int ey, int ex) {
  
    deque<pos> pq;
    set<pos> accessed;
    map<pos, pos> parents;
    int dep = 1;
    pq.push_back(pos{cy, cx});
    parents[pos{cy, cx}] = pos{-1, -1};
    grid[cy][cx] = dep;
    while(!pq.empty()) {
    	dep++;
        int d[4][2] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
        for (int i=0;i<4;i++) {
        	int ky = pq.front().y + d[i][0], kx = pq.front().x + d[i][1];
        	if (!(ky>=0&&ky<h&&kx>=0&&kx<w)) continue;
        	if (grid[ky][kx]!=0) continue;
			if (accessed.find(pos{ky, kx})!=accessed.end()) continue;
			pq.push_back(pos{ky, kx});
			parents[pos{ky, kx}] = pos{pq.front().y, pq.front().x};
  
        }
        accessed.insert(pq.front());
        pq.pop_front();
  
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].y][pq[i].x] = dep;
		}
    }
    if (accessed.find(pos{ey, ex})==accessed.end()) return -1;
    int step=-1;
    pos current = pos{ey, ex};
  
    while(current.x!=-1&&current.y!=-1) {
    	step++;
    	current = parents[current];
	}
	return step;
}

void path(vec grid, int cy, int cx, int ey, int ex) {
    deque<pos> pq;
    set<pos> accessed;
    map<pos, pos> parents;
    int dep = 1;
    pq.push_back(pos{cy, cx});
    parents[pos{cy, cx}] = pos{-1, -1};
    grid[cy][cx] = dep;
    while(!pq.empty()) {
    	dep++;
        int d[4][2] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
        for (int i=0;i<4;i++) {
        	int ky = pq.front().y + d[i][0], kx = pq.front().x + d[i][1];
        	if (!(ky>=0&&ky<h&&kx>=0&&kx<w)) continue;
        	if (grid[ky][kx]!=0) continue;
			if (accessed.find(pos{ky, kx})!=accessed.end()) continue;
			pq.push_back(pos{ky, kx});
			parents[pos{ky, kx}] = pos{pq.front().y, pq.front().x};
  
        }
        accessed.insert(pq.front());
        pq.pop_front();
  
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].y][pq[i].x] = dep;
		}
    }
    if (accessed.find(pos{ey, ex})==accessed.end()) return ;
    vector<pos> pth;
    pos current = pos{ey, ex};
    while(current.x!=-1&&current.y!=-1) {
    	pth.push_back(current);
    	current = parents[current];
	}
    for(int i=pth.size()-1;i>=0;i--) printf("(%d, %d)\n", pth[i].y, pth[i].x);
}

void labyrinth() {
    cin >> h >> w;
    int cy=0, cx=0, ey=h-1, ex=w-1;
	vec grid;
	grid.resize(h);
	for (int i=0;i<h;i++) grid[i].resize(w);
    for (int i=0;i<h;i++) {
        string s;cin >> s;
        for (int j=0;j<w;j++) {
            char p=s[j];
            if (p=='.') grid[i][j]=0;
            if (p=='#') grid[i][j]=-1;
            if (p=='S') {cy=i;cx=j;grid[i][j]=0;}
            if (p=='E') {ey=i;ex=j;grid[i][j]=0;}
        }
    }
    int r=step(grid, cy, cx, ey, ex);
    if (r==-1) cout << "oop!\n";
    else cout << r << endl;
};
#endif

