//Copyright (c) 2023-2023 NOIP Program Master Co, Ltd.All Right Reserved.
//Add version : v1.0.0-alpha|0x00
//Latest Update : v1.0.0-alpha|0x00
#include <bits/stdc++.h>
using namespace std;


#ifndef LABYRINTH3D_H
#define LABYRINTH3D_H
int d1, d2, d3;
#define vec3d vector<vector<vector<long long> > >
struct pos3d {
    int z, y, x;
};

bool operator< (const pos3d &a, const pos3d &b) {
    if (a.z != b.z) return a.z < b.z;
    if (a.y != b.y) return a.y < b.y;
    return a.x < b.x;
}

bool det3d(vec3d grid, int cz, int cy, int cx, int ez, int ey, int ex) {
    if (cz<0||cz>=d1||cy<0||cy>=d2||cx<0||cx>=d3) return false;
    if (grid[cz][cy][cx]==1) return false;
    if (cz==ez&&cy==ey&&cx==ex) return true;
    grid[cz][cy][cx] = 1;
    bool res=false;
    res |= det3d(grid, cz-1, cy, cx, ez, ey, ex);
    res |= det3d(grid, cz+1, cy, cx, ez, ey, ex);
    res |= det3d(grid, cz, cy-1, cx, ez, ey, ex);
    res |= det3d(grid, cz, cy+1, cx, ez, ey, ex);
    res |= det3d(grid, cz, cy, cx-1, ez, ey, ex);
    res |= det3d(grid, cz, cy, cx+1, ez, ey, ex);
    return res;
}

vec3d extend3d(vec3d grid, int cz, int cy, int cx) {
    if (cz<0||cz>=d1||cy<0||cy>=d2||cx<0||cx>=d3) return grid;
    if (grid[cz][cy][cx]==1) return grid;
    grid[cz][cy][cx] = 1;
    grid = extend3d(grid, cz-1, cy, cx);
    grid = extend3d(grid, cz+1, cy, cx);
    grid = extend3d(grid, cz, cy-1, cx);
    grid = extend3d(grid, cz, cy+1, cx);
    grid = extend3d(grid, cz, cy, cx-1);
    grid = extend3d(grid, cz, cy, cx+1);
    return grid;
}

int extendv3d(vec3d grid, int cz, int cy, int cx, int ez, int ey, int ex) {
  
    deque<pos3d> pq;
    set<pos3d> accessed;
    int dep = 1;
    pq.push_back(pos3d{cz, cy, cx});
  
    grid[cz][cy][cx] = dep;
    while(!pq.empty()) {
        int d[6][3] = {{-1, 0, 0}, {1, 0, 0}, {0, 0, 1}, {0, 1, 0}, {0, 0, -1}, {0, -1, 0}};
        for (int i=0;i<6;i++) {
        	int kz = pq.front().z + d[i][0], ky = pq.front().y + d[i][1], kx = pq.front().x + d[i][2];
        	if (kz>=0&&kz<d1&&ky>=0&&ky<d2&&kx>=0&&kx<d3&&grid[kz][ky][kx]==0) pq.push_back(pos3d{kz, ky, kx});
  
        }
        accessed.insert(pq.front());
        pq.pop_front();
        dep++;
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].z][pq[i].y][pq[i].x] = dep;
		}
    }
    int count=0;
    for (int i=0;i<d1;i++) {
    	for (int j=0;j<d2;j++) {
    		for (int k=0;k<d3;k++) {
    			if (grid[i][j][k]!=-1) count++;
    		}
		}
	}
	return count;
};

int step3d(vec3d grid, int cz, int cy, int cx, int ez, int ey, int ex) {
  
    deque<pos3d> pq;
    set<pos3d> accessed;
    map<pos3d, pos3d> parents;
    int dep = 1;
    pq.push_back(pos3d{cz, cy, cx});
    parents[pos3d{cz, cy, cx}] = pos3d{-1, -1, -1};
    grid[cz][cy][cx] = dep;
    while(!pq.empty()) {
    	dep++;
        int d[6][3] = {{-1, 0, 0}, {1, 0, 0}, {0, 0, 1}, {0, 1, 0}, {0, 0, -1}, {0, -1, 0}};
        for (int i=0;i<6;i++) {
        	int kz = pq.front().z + d[i][0], ky = pq.front().y + d[i][1], kx = pq.front().x + d[i][2];
        	if (!(kz>=0&&kz<d1&&ky>=0&&ky<d2&&kx>=0&&kx<d3)) continue;
        	if (grid[kz][ky][kx]!=0) continue;
			if (accessed.find(pos3d{kz, ky, kx})!=accessed.end()) continue;
			pq.push_back(pos3d{kz, ky, kx});
			parents[pos3d{kz, ky, kx}] = pos3d{pq.front().z, pq.front().y, pq.front().x};
        }
        accessed.insert(pq.front());
        pq.pop_front();
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].z][pq[i].y][pq[i].x] = dep;
		}
    }
    if (accessed.find(pos3d{ez, ey, ex})==accessed.end()) return -1;
    int step=-1;
    pos3d current = pos3d{ez, ey, ex};
  
    while(current.x!=-1&&current.y!=-1&&current.z!=-1) {
    	step++;
    	current = parents[current];
	}
	return step;
}

void path3d(vec3d grid, int cz, int cy, int cx, int ez, int ey, int ex) {
    deque<pos3d> pq;
    set<pos3d> accessed;
    map<pos3d, pos3d> parents;
    int dep = 1;
    pq.push_back(pos3d{cz, cy, cx});
    parents[pos3d{cz, cy, cx}] = pos3d{-1, -1, -1};
    grid[cz][cy][cx] = dep;
    while(!pq.empty()) {
    	dep++;
        int d[6][3] = {{-1, 0, 0}, {1, 0, 0}, {0, 0, 1}, {0, 1, 0}, {0, 0, -1}, {0, -1, 0}};
        for (int i=0;i<6;i++) {
        	int kz = pq.front().z + d[i][0], ky = pq.front().y + d[i][1], kx = pq.front().x + d[i][2];
        	if (!(kz>=0&&kz<d1&&ky>=0&&ky<d2&&kx>=0&&kx<d3)) continue;
        	if (grid[kz][ky][kx]!=0) continue;
			if (accessed.find(pos3d{kz, ky, kx})!=accessed.end()) continue;
			pq.push_back(pos3d{kz, ky, kx});
			parents[pos3d{kz, ky, kx}] = pos3d{pq.front().z, pq.front().y, pq.front().x};
  
        }
        accessed.insert(pq.front());
        pq.pop_front();
  
        for (int i=0;i<pq.size();i++) {
        	grid[pq[i].z][pq[i].y][pq[i].x] = dep;
		}
    }
    if (accessed.find(pos3d{ez, ey, ex})==accessed.end()) return ;
    vector<pos3d> pth;
    pos3d current = pos3d{ez, ey, ex};
    while(current.x!=-1&&current.y!=-1&&current.z!=-1) {
    	pth.push_back(current);
    	current = parents[current];
	}
    for(int i=pth.size()-1;i>=0;i--) printf("(%d, %d, %d)\n", pth[i].z, pth[i].y, pth[i].x);
}

void labyrinth3d() {
    int cz=0, cy=0, cx=0, ez=d1-1, ey=d2-1, ex=d3-1;
	vec3d grid;
	grid.resize(d1);
	for (int i=0;i<d1;i++) {
		grid[i].resize(d2);
		for (int j=0;j<d2;j++) grid[i][j].resize(d3);
	}

    for (int i=0;i<d1;i++) {
    	for (int j=0;j<d2;j++) {
	        string s;cin >> s;
	        for (int k=0;k<d3;k++) {
	            char p=s[k];
	            if (p=='.') grid[i][j][k]=0;
	            if (p=='#') grid[i][j][k]=-1;
	            if (p=='S') {cz=i;cy=j;cx=k;grid[i][j][k]=0;}
	            if (p=='E') {ez=i;ey=j;ex=k;grid[i][j][k]=0;}
	        }
		}
    }
    int r=step3d(grid, cz, cy, cx, ez, ey, ex);
    if (r==-1) cout << "Trapped!\n";
    else printf("Escaped in %d minute(s)\n", r);
};
#endif

