//Copyright (c) 2023-2024 NOIP Program Master Co, Ltd.All Right Reserved.
//Add version : v1.1.0-alpha(0x01)
//Latest Update : v1.1.1-alpha(0x02)
#include <bits/stdc++.h>
using namespace std;


#ifndef LIBRARY_H
#define LIBRARY_H
template<typename T> class Custom_heap {
	#define HEAP_LIMIT 65536
	private:
		int heap_pointer=0, comp=0;
		T heap_data[HEAP_LIMIT+1];
	public:
		Custom_heap() {
			fill(heap_data, heap_data+HEAP_LIMIT+1, 0);
		}
		void set_compare_mode(int m) {comp=m;}
		void push(T x) {
			if (heap_pointer==HEAP_LIMIT) throw "Custom_heap : Overflowed.";
			int cur;
			heap_data[cur=(++heap_pointer)] = x;
			while (cur!=1) {
				if ((heap_data[cur>>1]>heap_data[cur])^comp) {
					swap(heap_data[cur>>1], heap_data[cur]);
					cur>>=1;
				}
				else break;
			}
		}
		T front() {
			if (heap_pointer==0) throw "Custom_heap : Underflowed.";
			return heap_data[1];
		}
		void pop() {
			if (heap_pointer==0) throw "Custom_heap : Underflowed.";
			heap_data[1] = heap_data[heap_pointer--];
			int cur=1;
			while ((cur<<1)<=heap_pointer) {
				if ((cur<<1)+1>heap_pointer) {
					if ((heap_data[cur]>heap_data[cur<<1])^comp) {
						swap(heap_data[cur], heap_data[cur<<1]);
						cur<<=1;
					}
				}
				else {
					int next=0;
					if ((heap_data[cur<<1]>heap_data[(cur<<1)+1])^comp) next=cur<<1;
					else next=(cur<<1)+1;
					if ((heap_data[cur]>heap_data[next])^comp) {
						swap(heap_data[cur], heap_data[next]);
						cur<<=1;
					}
					else break;
				}
			}
		}
};

class DisjointSet {
	private:
		int djs_size, merge_count=0;
		vector<int> djs_pointer, djs_rank;
	public:
		DisjointSet(int sz) {
			//if (sz>DJS_LIMIT) throw "DisjointSet : Size overflowed.";
			djs_size = sz;
			djs_pointer.resize(sz);
			djs_rank.resize(sz);
			for (int i=0;i<djs_size;i++) djs_pointer[i] = i;
		}
		int find(int tar) {
			if (tar>djs_size) throw "DisjointSet : Index ovewrflowed.";
			if (djs_pointer[tar-1]==tar) return tar;
			return (djs_pointer[tar-1]=find(djs_pointer[tar-1]));
		}
		void merge(int a, int b) { 
			if (a>djs_size||b>djs_size) throw "DisjointSet : Index ovewrflowed.";
			a--;b--;
			int pa=find(a), pb=find(b);
			if (pa!=pb) merge_count++;
			if (djs_rank[pa]<=djs_rank[pb]) djs_pointer[pa] = pb;
			else djs_pointer[pb] = pa;
			if (djs_rank[pa]==djs_rank[pb]&&pa!=pb) djs_rank[pb]++; 
		}
		int unique_count() {return djs_size - merge_count;}
		bool inset(int a, int b) {return find(a)==find(b);}
};
#endif
