//Copyright (c) 2023-2024 NOIP Program Master Co, Ltd.All Right Reserved.
//Add version : v1.2.0-beta|0x03 -b
//Latest Update : v1.2.0-beta|0x03 -b
#include <bits/stdc++.h>
using namespace std;


#ifndef SP_H
#define SP_H
typedef long long ll;
typedef vector<map<int, ll> > adjacent_table;
typedef vector<vector<ll> > adjacent_matrix;
struct SPFA_result {
	vector<ll> mindist;
	set<int> inf_sp;
};
SPFA_result SPFA(adjacent_table graph, int source) {
	int sz = graph.size();
	int inq[sz];
	set<int> inf_sp;
	vector<ll> mindist;
	mindist.resize(sz);
	fill(mindist.begin(), mindist.end(), LONG_LONG_MAX/2);
	fill(inq, inq+sz, 0);
	map<int, int> ncount;
	queue<int> q;q.push(source);mindist[source]=0;inq[source] = 1;
	while (!q.empty()) {
		int c=q.front();q.pop();inq[c] = 0;
		if (!ncount.count(c)) ncount[c] = 0;
		ncount[c]++;
		if (ncount[c]==sz) {inf_sp.insert(c);}
		if (inf_sp.count(c)) continue;
		for (map<int, ll>::iterator it=graph[c].begin();it!=graph[c].end();it++) {
			int t = it->first;
			if (mindist[t]>mindist[c]+it->second) {
				mindist[t]=mindist[c]+it->second;
				if (!inq[t]) {
					inq[t]=1;
					q.push(t);
				}
			}
		}
	}
	SPFA_result res;
	res.mindist = mindist;
	res.inf_sp = inf_sp;
	return res;
}
vector<ll> Dijkstra(adjacent_table graph, int source) {
	int sz=graph.size();
	vector<ll> mindist; mindist.resize(sz);
	fill(mindist.begin(), mindist.end(), LONG_LONG_MAX/2); mindist[source]=0;
	int vis[sz]; fill(vis, vis+sz, 0);
	typedef pair<long long, int> pr;
	priority_queue<pr, vector<pr>, greater<pr> > pq; pq.push({0, source});
	while (!pq.empty()) {
		pr c = pq.top();pq.pop();
		if (vis[c.second]) continue;
		vis[c.second] = 1;
		for (map<int, ll>::iterator it=graph[c.second].begin();it!=graph[c.second].end();it++) {
			int t = it->first;
			if (mindist[t]>mindist[c.second]+it->second) {
				mindist[t]=mindist[c.second]+it->second;
				pq.push({mindist[t], t});
			}
		}
	}
	return mindist;
}

vector<vector<ll> > Floyd(adjacent_matrix mx) {
	int sz=mx.size();
	vector<vector<ll> > mindist;
	mindist.resize(sz);
	for (int i=0;i<sz;i++) {
		mindist[i].resize(sz);
		for (int j=0;j<sz;j++) {
			if (mx[i][j]!=0) mindist[i][j] = mx[i][j];
			else mindist[i][j] = LONG_LONG_MAX/2;
		}
	}
	for (int t=0;t<sz;t++) {
		for (int i=0;i<sz;i++) {
			for (int j=0;j<sz;j++) mindist[i][j] = min(mindist[i][j], mindist[i][k]+mindist[k][j]);
		}
	}
	return mindist;
}
#endif